<template>
  <div class="beneficiary-toolbar">
    <AtomSearchbar
      class="beneficiary-search fr-mr-2w"
      label="Rechercher un·e bénéficiaire"
      name="beneficiary-search"
      :search-fn="searchBeneficiariesFn"
    >
      <template #result="{ result: beneficiary }">
        <NuxtLink
          :to="`${Routes.Beneficiary(
            beneficiary.id
          )}?${ORIGIN_PAGE_PARAMETER}=${route.path}`"
          target="_self"
          class="fr-btn fr-btn--tertiary-no-outline result"
        >
          {{ beneficiaryToSearchResult(beneficiary) }}
        </NuxtLink>
      </template>
    </AtomSearchbar>
    <NuxtLink
      :to="Routes.BeneficiariesAdd"
      class="fr-btn fr-btn--lg fr-btn--icon-left fr-icon-user-add-line add-beneficiary-btn"
      target="_self"
    >
      Ajouter un·e bénéficaire
    </NuxtLink>
  </div>
</template>

<script setup>
  import { beneficiaryToSearchResult } from '~~/utils/beneficiary'
  import { ORIGIN_PAGE_PARAMETER } from '~~/utils/constants'
  import { Routes } from '~/utils/routing/routes'

  const { $searchBeneficiaries } = useNuxtApp()
  const route = useRoute()

  async function searchBeneficiariesFn(search) {
    return await $searchBeneficiaries(search)
  }
</script>

<style scoped>
  .beneficiary-toolbar {
    display: flex;
  }

  .add-beneficiary-btn {
    border-radius: 2.25rem;
  }

  .beneficiary-search {
    flex: 1 1 auto;
  }

  .result {
    width: 100%;
  }
</style>
